Description

Hello,

Redmine 3.4.6 doesn't work with mercurial 4.7.

Logs say that in redmine/lib/redmine/scm/adapters/mercurial/redminehelper.py, module cmdutil does not have a command method.

Checking mercurial 4.6.1 source, this method is indeed deprecated ; it must have been removed from 4.7.

I got it back to work by following deprecation instruction which was "used registrar.command instead":

import re, time, cgi, urllib

from mercurial import cmdutil, commands, node, error, hg, registrar # added registrar

cmdtable = {}

command = registrar.command(cmdtable) # replaced cmdutil with registrar

 Regards.

Associated revisions

Revision 17474 - 2018-08-25 10:40 - Go MAEDA

Mercurial 4.7 compatibility (#29413).

Patch by Frédéric Fondement.

Revision 17475 - 2018-08-25 11:33 - Go MAEDA

Merged r17474 from trunk to 3.4-stable (#29413).

Revision 17476 - 2018-08-25 11:48 - Go MAEDA

Merged r17474 from trunk to 3.3-stable (#29413).

History

#1 - 2018-08-20 11:22 - Go MAEDA

- Target version set to 3.3.9

#2 - 2018-08-20 13:37 - Frédéric Fondement

Another problem with exploring branches using hg 4.7.

It can be solved by modifying _changectx of redmine/scm/adapters/mercurial/redminehelper.py:

def _changectx(repo, rev):

    if hasattr(repo, 'branchtip') and rev in repo.branchmap(): # mercurial 4.7 doesn't select on branch name

        rev = repo.branchtip(rev)

    if hasattr(repo, 'changectx'):

        return repo.changectx(rev)

    else:

        return repo[rev]

#3 - 2018-08-20 13:57 - Frédéric Fondement

Maybe clever:

def _changectx(repo, rev):
    if isinstance(rev, str):

        rev = repo.lookup(rev)

    if hasattr(repo, 'changectx'):

        return repo.changectx(rev)

    else:

        return repo[rev]

#4 - 2018-08-20 14:04 - Go MAEDA

Frédéric Fondement, thank you for reporting the issue and submitting the workaround. Do you know it also work with Mercurial < 4.7?

#5 - 2018-08-20 14:39 - Frédéric Fondement

Good point !

The change I proposed fails with 4.0.

Here is the new version sucessfully tested with hg 4.7, 4.6, 4.5, 4.4, 4.1, 4.0, 3.9, 3.5, 2.6.2 (the older I can easily access - using pip):

import re, time, cgi, urllib

from mercurial import cmdutil, commands, node, error, hg, registrar

cmdtable = {}

command = registrar.command(cmdtable) if hasattr(registrar, 'command') else cmdutil.command(cmdtable)

 
def _changectx(repo, rev):

    if isinstance(rev, str):

        rev = repo.lookup(rev)

    if hasattr(repo, 'changectx'):

        return repo.changectx(rev)

    else:

        return repo[rev]

#6 - 2018-08-22 05:48 - Go MAEDA

- File 29413-mercurial-fix.diff added

- Category set to SCM

I made a patch file from #29413#note-5.

#7 - 2018-08-22 18:23 - Go MAEDA

LGTM. The test suite passed with both Mercurial 2.6.2 and 4.7.

#8 - 2018-08-25 10:54 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

#9 - 2018-08-25 11:48 - Go MAEDA

- Status changed from Resolved to Closed

- Resolution set to Fixed

Committed. Thank you for reporting and fixing the issue.

Files

29413-mercurial-fix.diff 866 Bytes 2018-08-22 Go MAEDA
